package cn.net.cpzslibs.prot.handset;

import com.google.gson.Gson;

import java.io.DataInputStream;
import java.io.DataOutputStream;
import java.io.IOException;
import java.net.Socket;

import cn.net.cpzslibs.prot.ProtBase;
import cn.net.cpzslibs.prot.SocketCreate;
import cn.net.cpzslibs.prot.handset.bean.Prot10086CheckTypeResult;
import cn.net.cpzslibs.prot.handset.bean.Prot10086SendBeanCheck;
import cn.net.cpzslibs.prot.utils.StrUtils;

/**
 * @author 作者 李扬:
 * @date 创建时间：2017-5-11 上午9:17:09
 * @version 1.0
 * @parameter 查询是类型1 种2 养 3 种养 4 种子
 * @since
 * @return
 */
public class Prot10086CheckType extends ProtBase {

	/**
	 * 是否成功
	 */
	private final short iTaskCode10086 = 10086;

	private Gson gson;

	private Prot10086CheckTypeResult checkResult;

	public Prot10086CheckType() {
		gson = new Gson();
	}

	public Prot10086CheckTypeResult getCheckResult() {
		return checkResult;
	}

	public void setCheckResult(Prot10086CheckTypeResult checkResult) {
		this.checkResult = checkResult;
	}

	public void dealCheckType(SocketCreate create,
                              Prot10086SendBeanCheck checkBean) throws IOException {
		recProt(create.getSocket(), create.getDos(), create.getDis(), checkBean);
	}

	private void recProt(Socket socket, DataOutputStream dos,
			DataInputStream dis, Prot10086SendBeanCheck checkBean)
			throws IOException {
		if (socket.isConnected()) {

			if (!socket.isOutputShutdown()) {
				// 发送登录信息
				debugLog(iTaskCode10086, "开始发送登录信息");
				sendProt(dos, checkBean);
			}
		}
		if (socket.isConnected()) {
			if (!socket.isInputShutdown()) {
				recLoginDis(dis);
			}
		}
	}

	/**
	 * 读取JSon数据
	 * 
	 * @param dis
	 * @throws IOException
	 */
	private void recLoginDis(DataInputStream dis) throws IOException {
		debugLog(iTaskCode10086, "获取接收的数据");
		recHeader(dis);
		int jsonLength = getiRecBodySize() - 2;
		String jsonData = getUTF8(dis, jsonLength);
		debugLog(iTaskCode10086, jsonData);
		if (!StrUtils.isEmpty(jsonData)) {
			checkResult = gson.fromJson(jsonData,
					Prot10086CheckTypeResult.class);
		}
		recCheckCode(dis);
	}

	/**
	 * 发送JSon数据到服务器
	 * @param dos
	 * @param iUserType
	 * @param loginBean
	 * @throws IOException
	 */
	private void sendProt(DataOutputStream dos, Prot10086SendBeanCheck checkBean)
			throws IOException {
		String bodyContent = gson.toJson(checkBean).toString();
		short bodySize = countBodySize(bodyContent);
		sendHeader(dos, iTaskCode10086, bodySize);// 84
		dos.write(bodyContent.getBytes("UTF-8"));
		// sendCheckCode(dos);
		sendCheckCoded(dos, bodyContent.getBytes("UTF-8"));
	}

}
